/****************************/
/*                          */
/* tHgt@C */
/* Kvȃf[^o   */
/*                          */
/****************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	BUFSIZE		0x800

void	readfont(FILE *fontfp, unsigned char buff[BUFSIZE], long int offset, int stchr, int edchr);

int main(int argc, char **argv)
{
	FILE	*fontfp,*outfp;

	unsigned char	buff[BUFSIZE];

	int		x,y;
	int		m,n,i,j,k;
	int		filelen;
	int		f0,f1,f2,f3,f4,f5,f6,f7;

	if (argc != 3) {
		fprintf(stderr, "Usage: convletter fontfile outfile\n");
		exit(1);
	}

/* open files */

	if ((fontfp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	filelen = BUFSIZE;

	for (i = 0;i < filelen;i ++) {
		buff[i] = 0x00;
	}

	readfont(fontfp, buff, 0x00c8, 0x21, 0x21); /* ! */
	readfont(fontfp, buff, 0x01c0, 0x22, 0x22); /* " */
	readfont(fontfp, buff, 0x0318, 0x23, 0x23); /* # */
	readfont(fontfp, buff, 0x02f8, 0x24, 0x24); /* $ */
	readfont(fontfp, buff, 0x0310, 0x25, 0x25); /* % */
	readfont(fontfp, buff, 0x0320, 0x26, 0x26); /* & */
	readfont(fontfp, buff, 0x01b0, 0x27, 0x27); /* ' */
	readfont(fontfp, buff, 0x01c8, 0x28, 0x29); /* () */
	readfont(fontfp, buff, 0x0328, 0x2a, 0x2a); /* * */
	readfont(fontfp, buff, 0x0258, 0x2b, 0x2b); /* + */
	readfont(fontfp, buff, 0x0098, 0x2c, 0x2c); /* , */
	readfont(fontfp, buff, 0x0260, 0x2d, 0x2d); /* - */
	readfont(fontfp, buff, 0x00a0, 0x2e, 0x2e); /* . */
	readfont(fontfp, buff, 0x0170, 0x2f, 0x2f); /* / */
	readfont(fontfp, buff, 0x06d8, 0x30, 0x39); /* 0`9 */
	readfont(fontfp, buff, 0x00b0, 0x3a, 0x3b); /* :; */
	readfont(fontfp, buff, 0x0208, 0x3c, 0x3c); /* < */
	readfont(fontfp, buff, 0x0280, 0x3d, 0x3d); /* = */
	readfont(fontfp, buff, 0x0210, 0x3e, 0x3e); /* > */
	readfont(fontfp, buff, 0x00c0, 0x3f, 0x3f); /* ? */
	readfont(fontfp, buff, 0x0330, 0x40, 0x40); /* @ */
	readfont(fontfp, buff, 0x0760, 0x41, 0x5a); /* A`Z */
	readfont(fontfp, buff, 0x01e8, 0x5b, 0x5b); /* [ */
	readfont(fontfp, buff, 0x02f0, 0x5c, 0x5c); /* \ */
	readfont(fontfp, buff, 0x01f0, 0x5d, 0x5d); /* ] */
	readfont(fontfp, buff, 0x00f8, 0x5e, 0x5e); /* ^ */
	readfont(fontfp, buff, 0x0108, 0x5f, 0x5f); /* _ */
	readfont(fontfp, buff, 0x0860, 0x61, 0x7a); /* a`z */
	readfont(fontfp, buff, 0x01f8, 0x7b, 0x7b); /* { */
	readfont(fontfp, buff, 0x0190, 0x7c, 0x7c); /* | */
	readfont(fontfp, buff, 0x0200, 0x7d, 0x7d); /* } */
	readfont(fontfp, buff, 0x0180, 0x7e, 0x7e); /* ~ */
	readfont(fontfp, buff, 0x0350, 0x84, 0x85); /*  */
	readfont(fontfp, buff, 0x0bd8, 0x86, 0x86); /*  */
	readfont(fontfp, buff, 0x0950, 0x87, 0x87); /*  */
	readfont(fontfp, buff, 0x0960, 0x88, 0x88); /*  */
	readfont(fontfp, buff, 0x0970, 0x89, 0x89); /*  */
	readfont(fontfp, buff, 0x0980, 0x8a, 0x8a); /*  */
	readfont(fontfp, buff, 0x0990, 0x8b, 0x8b); /*  */
	readfont(fontfp, buff, 0x0b60, 0x8c, 0x8c); /*  */
	readfont(fontfp, buff, 0x0b70, 0x8d, 0x8d); /*  */
	readfont(fontfp, buff, 0x0b80, 0x8e, 0x8e); /*  */
	readfont(fontfp, buff, 0x0a60, 0x8f, 0x8f); /*  */
	readfont(fontfp, buff, 0x0958, 0x91, 0x91); /*  */
	readfont(fontfp, buff, 0x0968, 0x92, 0x92); /*  */
	readfont(fontfp, buff, 0x0978, 0x93, 0x93); /*  */
	readfont(fontfp, buff, 0x0988, 0x94, 0x94); /*  */
	readfont(fontfp, buff, 0x0998, 0x95, 0x95); /*  */
	readfont(fontfp, buff, 0x09a0, 0x96, 0x96); /*  */
	readfont(fontfp, buff, 0x09b0, 0x97, 0x97); /*  */
	readfont(fontfp, buff, 0x09c0, 0x98, 0x98); /*  */
	readfont(fontfp, buff, 0x09d0, 0x99, 0x99); /*  */
	readfont(fontfp, buff, 0x09e0, 0x9a, 0x9a); /*  */
	readfont(fontfp, buff, 0x09f0, 0x9b, 0x9b); /*  */
	readfont(fontfp, buff, 0x0a00, 0x9c, 0x9c); /*  */
	readfont(fontfp, buff, 0x0a10, 0x9d, 0x9d); /*  */
	readfont(fontfp, buff, 0x0a20, 0x9e, 0x9e); /*  */
	readfont(fontfp, buff, 0x0a30, 0x9f, 0x9f); /*  */
	readfont(fontfp, buff, 0x0090, 0xa1, 0xa1); /* B */
	readfont(fontfp, buff, 0x0228, 0xa2, 0xa3); /* uv */
	readfont(fontfp, buff, 0x0088, 0xa4, 0xa4); /* A */
	readfont(fontfp, buff, 0x00a8, 0xa5, 0xa5); /* E */
	readfont(fontfp, buff, 0x0ec8, 0xa6, 0xa6); /*  */
	readfont(fontfp, buff, 0x0c40, 0xa7, 0xa7); /* @ */
	readfont(fontfp, buff, 0x0c50, 0xa8, 0xa8); /* B */
	readfont(fontfp, buff, 0x0c60, 0xa9, 0xa9); /* D */
	readfont(fontfp, buff, 0x0c70, 0xaa, 0xaa); /* F */
	readfont(fontfp, buff, 0x0c80, 0xab, 0xab); /* H */
	readfont(fontfp, buff, 0x0e50, 0xac, 0xac); /*  */
	readfont(fontfp, buff, 0x0e60, 0xad, 0xad); /*  */
	readfont(fontfp, buff, 0x0e70, 0xae, 0xae); /*  */
	readfont(fontfp, buff, 0x0d50, 0xaf, 0xaf); /* b */
	readfont(fontfp, buff, 0x0158, 0xb0, 0xb0); /* [ */
	readfont(fontfp, buff, 0x0c48, 0xb1, 0xb1); /* A */
	readfont(fontfp, buff, 0x0c58, 0xb2, 0xb2); /* C */
	readfont(fontfp, buff, 0x0c68, 0xb3, 0xb3); /* E */
	readfont(fontfp, buff, 0x0c78, 0xb4, 0xb4); /* G */
	readfont(fontfp, buff, 0x0c88, 0xb5, 0xb5); /* I */
	readfont(fontfp, buff, 0x0c90, 0xb6, 0xb6); /* J */
	readfont(fontfp, buff, 0x0ca0, 0xb7, 0xb7); /* L */
	readfont(fontfp, buff, 0x0cb0, 0xb8, 0xb8); /* N */
	readfont(fontfp, buff, 0x0cc0, 0xb9, 0xb9); /* P */
	readfont(fontfp, buff, 0x0cd0, 0xba, 0xba); /* R */
	readfont(fontfp, buff, 0x0ce0, 0xbb, 0xbb); /* T */
	readfont(fontfp, buff, 0x0cf0, 0xbc, 0xbc); /* V */
	readfont(fontfp, buff, 0x0d00, 0xbd, 0xbd); /* X */
	readfont(fontfp, buff, 0x0d10, 0xbe, 0xbe); /* Z */
	readfont(fontfp, buff, 0x0d20, 0xbf, 0xbf); /* \ */
	readfont(fontfp, buff, 0x0d30, 0xc0, 0xc0); /* ^ */
	readfont(fontfp, buff, 0x0d40, 0xc1, 0xc1); /* ` */
	readfont(fontfp, buff, 0x0d58, 0xc2, 0xc2); /* c */
	readfont(fontfp, buff, 0x0d68, 0xc3, 0xc3); /* e */
	readfont(fontfp, buff, 0x0d78, 0xc4, 0xc4); /* g */
	readfont(fontfp, buff, 0x0d88, 0xc5, 0xc9); /* i`m */
	readfont(fontfp, buff, 0x0db0, 0xca, 0xca); /* n */
	readfont(fontfp, buff, 0x0dc8, 0xcb, 0xcb); /* q */
	readfont(fontfp, buff, 0x0de0, 0xcc, 0xcc); /* t */
	readfont(fontfp, buff, 0x0df8, 0xcd, 0xcd); /* w */
	readfont(fontfp, buff, 0x0e10, 0xce, 0xce); /* z */
	readfont(fontfp, buff, 0x0e28, 0xcf, 0xd3); /* }` */
	readfont(fontfp, buff, 0x0e58, 0xd4, 0xd4); /*  */
	readfont(fontfp, buff, 0x0e68, 0xd5, 0xd5); /*  */
	readfont(fontfp, buff, 0x0e78, 0xd6, 0xd6); /*  */
	readfont(fontfp, buff, 0x0e80, 0xd7, 0xdb); /* ` */
	readfont(fontfp, buff, 0x0eb0, 0xdc, 0xdc); /*  */
	readfont(fontfp, buff, 0x0ed0, 0xdd, 0xdd); /*  */
	readfont(fontfp, buff, 0x00d0, 0xde, 0xde); /* J */
	readfont(fontfp, buff, 0x00d8, 0xdf, 0xdf); /* K */
	readfont(fontfp, buff, 0x0a40, 0xe0, 0xe0); /*  */
	readfont(fontfp, buff, 0x0a50, 0xe1, 0xe1); /*  */
	readfont(fontfp, buff, 0x0a68, 0xe2, 0xe2); /*  */
	readfont(fontfp, buff, 0x0a78, 0xe3, 0xe3); /*  */
	readfont(fontfp, buff, 0x0a88, 0xe4, 0xe4); /*  */
	readfont(fontfp, buff, 0x0a98, 0xe5, 0xe9); /* ȁ` */
	readfont(fontfp, buff, 0x0ac0, 0xea, 0xea); /*  */
	readfont(fontfp, buff, 0x0ad8, 0xeb, 0xeb); /*  */
	readfont(fontfp, buff, 0x0af0, 0xec, 0xec); /*  */
	readfont(fontfp, buff, 0x0b08, 0xed, 0xed); /*  */
	readfont(fontfp, buff, 0x0b20, 0xee, 0xee); /*  */
	readfont(fontfp, buff, 0x0b38, 0xef, 0xf3); /* ܁` */
	readfont(fontfp, buff, 0x0b68, 0xf4, 0xf4); /*  */
	readfont(fontfp, buff, 0x0b78, 0xf5, 0xf5); /*  */
	readfont(fontfp, buff, 0x0b88, 0xf6, 0xf6); /*  */
	readfont(fontfp, buff, 0x0b90, 0xf7, 0xfb); /* ` */
	readfont(fontfp, buff, 0x0bc0, 0xfc, 0xfc); /*  */
	readfont(fontfp, buff, 0x0be0, 0xfd, 0xfd); /*  */


	i = 0x80;		/* Xy[h */
	buff[i*8+0] = 0x10;
	buff[i*8+1] = 0x38;
	buff[i*8+2] = 0x7c;
	buff[i*8+3] = 0xfe;
	buff[i*8+4] = 0xfe;
	buff[i*8+5] = 0xd6;
	buff[i*8+6] = 0x38;
	buff[i*8+7] = 0x00;

	i = 0x81;		/* n[g */
	buff[i*8+0] = 0x6c;
	buff[i*8+1] = 0xfe;
	buff[i*8+2] = 0xfe;
	buff[i*8+3] = 0xfe;
	buff[i*8+4] = 0x7c;
	buff[i*8+5] = 0x38;
	buff[i*8+6] = 0x10;
	buff[i*8+7] = 0x00;

	i = 0x82;		/* Nu */
	buff[i*8+0] = 0x38;
	buff[i*8+1] = 0x38;
	buff[i*8+2] = 0x10;
	buff[i*8+3] = 0xfe;
	buff[i*8+4] = 0xfe;
	buff[i*8+5] = 0xd6;
	buff[i*8+6] = 0x38;
	buff[i*8+7] = 0x00;

	i = 0x83;		/* _C */
	buff[i*8+0] = 0x10;
	buff[i*8+1] = 0x38;
	buff[i*8+2] = 0x7c;
	buff[i*8+3] = 0xfe;
	buff[i*8+4] = 0x7c;
	buff[i*8+5] = 0x38;
	buff[i*8+6] = 0x10;
	buff[i*8+7] = 0x00;

	for (i = 0;i < filelen;i ++) {
		fputc(buff[i],outfp);
	}

	fclose(fontfp);
	fclose(outfp);

	return(0);
}

void	readfont(FILE *fontfp, unsigned char buff[BUFSIZE], long int offset, int stchr, int edchr)
{
	int		i,y;
	int		f0,f1,f2,f3,f4,f5,f6,f7;
	int		sft;

	fseek(fontfp,offset,SEEK_SET);
	for (i = stchr;i <= edchr;i ++) {
		f0 = fgetc(fontfp);
		f1 = fgetc(fontfp);
		f2 = fgetc(fontfp);
		f3 = fgetc(fontfp);
		f4 = fgetc(fontfp);
		f5 = fgetc(fontfp);
		f6 = fgetc(fontfp);
		f7 = fgetc(fontfp);
		sft = 0x01;
		for (y = 0;y < 8;y ++) {
			buff[i*8+y] =
				( ((f0 & sft) != 0x00) ? 0x80 : 0x00) +
				( ((f1 & sft) != 0x00) ? 0x40 : 0x00) +
				( ((f2 & sft) != 0x00) ? 0x20 : 0x00) +
				( ((f3 & sft) != 0x00) ? 0x10 : 0x00) +
				( ((f4 & sft) != 0x00) ? 0x08 : 0x00) +
				( ((f5 & sft) != 0x00) ? 0x04 : 0x00) +
				( ((f6 & sft) != 0x00) ? 0x02 : 0x00) +
				( ((f7 & sft) != 0x00) ? 0x01 : 0x00);
			sft *= 2;
		}
	}

	return;

}

