/************************************/
/* make pict_list                   */
/*                                  */
/* 摜t@C̏ꏊ̃Xg */
/************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


int main(int argc, char **argv)
{
	FILE	*infp, *outtxtfp;

	int		fnum;
	int		sttrk,stsec,edtrk,edsec;
	int		trkno,secno;

	if (argc != 3) {
		fprintf(stderr, "Usage: mkplist inputfile outtxtlist\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outtxtfp = fopen(argv[2], "w")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	for (fnum = 0;;fnum ++) {
		sttrk = fgetc(infp);
		if (sttrk == EOF) {
			fprintf(stderr, "Illigal file\n");
			exit(1);
		}
		stsec = fgetc(infp);
		if (stsec == EOF) {
			fprintf(stderr, "Illigal file\n");
			exit(1);
		}
		secno = fgetc(infp);
		if (secno == EOF) {
			fprintf(stderr, "Illigal file\n");
			exit(1);
		}
		if (sttrk == 0xff && stsec == 0xff && secno == 0xff) {
			break;
		}

		secno --;
		trkno = secno / 16;
		secno = secno - trkno*16;

		edtrk = sttrk + trkno;
		edsec = stsec + secno;
		if (edsec > 16) {
			edtrk ++;
			edsec -= 16;
		}

		fprintf(outtxtfp,"pict%02d %d %d %d %d\n", fnum, sttrk, stsec, edtrk, edsec);

	}


	fclose(infp);
	fclose(outtxtfp);

	return(0);

}

