;
; BIOSppb`
;

	relaxed on

;
; 荞݊֘A
;
	org	$8000

INT_TABLE:
	dw	INTDT0		; 0x00
	dw	INTKEYIN	; 0x02iKEYINPUTj
	dw	INTDT0		; 0x04iRS-232Cj
	dw	INTTIMER	; 0x06iTIMERj
	dw	INTDT1		; 0x08iCMT READj
	dw	INTDT0		; 0x0A
	dw	INTDT0		; 0x0C
	dw	INTDT1		; 0x0EiL[́j
	dw	INTDT1		; 0x10iL[́j
	dw	INTDT0		; 0x12iCMT ERRORj
	dw	INTKEYIN	; 0x14iL[́j
	dw	INTGAMEKEY	; 0x16iQ[L[́j
	dw	INTDT0		; 0x18iTVRj
	dw	INTDT0		; 0x1AiTIME֘Aj
	dw	INTDT1		; 0x1CiTIME֘Aj
	dw	INTDT0		; 0x1E
	dw	INTDT0		; 0x20iVOICEj
	dw	INTVSYNC	; 0x22iVSYNCj

TIMERCNT:
	db	$00		; 0x8024F^C}JEgp
VSYNCBUF:
	db	$00		; 0x8025FVSYNCobt@
KEYCNT:
	db	$00		; 0x8026FI[gs[g̃LZpJE^
KEYDATA:
	db	$00		; 0x8027FL[̓obt@
GAMEDATA:
	db	$00		; 0x8028FQ[L[̓obt@
CURON:
	db	$00		; 0x8029FJ[\\tO
CURCNT:
	db	$00		; 0x8029FJ[\_ŗpJE^

;
; 荞ݏI[if[^PoCgM{Ȃj
;
INTDT1:
	push	af
	call	GETSUBCPU
	pop	af
;
; 荞ݏI[iȂj
;
INTDT0:
	ei
	ret


;
; TuCPUPoCgf[^M
;
; RETFAreg=Mf[^
;
GETSUBCPU:
	ld	a,$0c
	out	($93),a
.wait:
	in	a,($92)
	and	$20
	jr	z,.wait
	ld	a,$0d
	out	($93),a
	in	a,($90)
	ret

;
; TuCPUւPoCgf[^𑗐M
;
; Areg=Mf[^
;
SETSUBCPU:
	push	af
	ld	a,$08
	out	($93),a
.wait:
	in	a,($92)
	and	$80
	jr	z,.wait
	ld	a,$09
	out	($93),a
	pop	af
	out	($90),a
	ret

;
; L[͊荞
;
; ʏL[́AASCIIR[h
; GRAPH+L[̏ꍇ́AASCIIR[h
; t@NVL[̏ꍇ́Af0h`f9h
; STOPL[̏ꍇ́Afah
; CAPSL[̏ꍇ́Afbh
;
INTKEYIN:
	push	af
	xor	a
	ld	(KEYCNT),a
	call	GETSUBCPU
	ld	(KEYDATA),a
	pop	af
	ei
	ret

;
; VSYNC荞
;
INTVSYNC:
	push	af
	ld	a,$01
	ld	(VSYNCBUF),a
	pop	af
	ei
	ret

;
; ^C}荞
;
INTTIMER:
	push	af

	ld	a,(TIMERCNT)
	inc	a
	and	$07
	ld	(TIMERCNT),a
	jr	nz,.next3

	ld	a,(KEYCNT)
	inc	a
	and	$1f
	ld	(KEYCNT),a
	jr	nz,.next1
	xor	a
	ld	(KEYDATA),a	; ^C}AL[obt@NA
.next1:

	ld	a,(CURON)
	or	a
	jr	z,.next3

	ld	a,(CURCNT)
	inc	a
	and	$3f
	ld	(CURCNT),a
	jr	nz,.next2
	ld	a,(F_COL)
	call	CURDRAW
	jr	.next3
.next2:
	cp	$20
	jr	nz,.next3
	ld	a,(B_COL)
	call	CURDRAW
.next3:
	pop	af
	ei
	ret

;
; Q[L[荞
;
INTGAMEKEY:
	push	af

	call	GETSUBCPU
	ld	(GAMEDATA),a

	pop	af
	ei
	ret



;
; SCREEN2pR\[
;

	org	$8100

	jp	PNTCHR		; 0x8100
	jp	CURSORON	; 0x8103
	jp	CURSOROFF	; 0x8106


	org	$8110

CURY:	db	17		; 0x8110
CURX:	db	0		; 0x8111
MINY:	db	17		; 0x8112
MAXY:	db	24		; 0x8113
F_COL:	db	$0f		; 0x8114
B_COL:	db	$08		; 0x8115


;
; J[\ON
;
CURSORON:
	ld	a,$ff
	ld	(CURCNT),a
	ld	(CURON),a
	ret

;
; J[\OFF
;
CURSOROFF:
	xor	a
	ld	(CURON),a
	ld	a,(B_COL)
	call	CURDRAW
	ret

;
; P\
;
PNTCHR:
	cp	$08		; BS
	jr	z,CUR_BS
	cp	$0a		; LF
	jp	z,CUR_LF
	cp	$0c		; ʃNA
	jp	z,CLSSCR

	push	bc
	push	af

	push	af
	ld	a,(CURON)
	ld	c,a
	or	a
	call	nz,CURSOROFF
	pop	af

	call	PNTCHRSUB	; P\Tu
	call	CUR_NEXT	; J[\Eɓ

	ld	a,c
	or	a
	call	nz,CURSORON

	pop	af
	pop	bc
	ret


;
; J[\ɓ
;
CUR_NEXT:
	push	af

	ld	a,(CURX)
	inc	a
	ld	(CURX),a
	cp	40
	call	nc,CUR_LF

	pop	af
	ret


;
; s
;
CUR_LF:
	push	af
	push	bc

	ld	a,(CURON)
	ld	c,a
	or	a
	call	nz,CURSOROFF

	xor	a
	ld	(CURX),a

	ld	a,(CURY)
	inc	a
	ld	(CURY),a
	ld	b,a
	ld	a,(MAXY)
	cp	b
	jr	nc,.end

	ld	(CURY),a

	call	CUR_SCROLL

.end:
	ld	a,c
	or	a
	call	nz,CURSORON

	pop	bc
	pop	af
	ret

;
; J[\Oɖ߂āA
;
CUR_BS:
	push	af
	push	bc

	ld	a,(CURON)
	ld	c,a
	or	a
	call	nz,CURSOROFF

	ld	a,$ff
	ld	(CURCNT),a
	ld	a,(B_COL)
	call	CURDRAW

	ld	a,(CURX)
	or	a
	jr	z,.lp1
	dec	a
	ld	(CURX),a
.lp1:
	ld	a,' '
	call	PNTCHRSUB	; P\Tu

	ld	a,c
	or	a
	call	nz,CURSORON

	pop	bc
	pop	af
	ret


;
; LN^ʃXN[
;
CUR_SCROLL:
	push	bc
	push	de
	push	hl

	ld	a,(MINY)
	ld	b,a

	add	a,a		; x2
	add	a,a		; x4
	add	a,a		; x8
	ld	c,a		; XN[Jns

	ld	a,(MAXY)
	inc	a
	sub	b
	add	a,a		; x2
	add	a,a		; x4
	add	a,a		; x8
	sub	4
	ld	b,a		; XN[s

	push	bc
	call	SCROLL_SUB

	ld	a,(MAXY)
	add	a,a		; x2
	add	a,a		; x4
	add	a,a		; x8
	add	a,4
	ld	c,a

	ld	b,4		; NAs
	call	CLSLINE

	pop	bc
	call	SCROLL_SUB

	pop	hl
	pop	de
	pop	bc
	ret


;
; XN[Tu
;
; CFXN[Jns
; BFs
;
SCROLL_SUB:
	ld	a,$ea		; ڃANZX[h
	out	($c8),a

	srl	b

.lp3:
	push	bc

	ld	a,c
	call	CALCVRAM_L	; ]
	ex	de,hl

	add	a,4
	call	CALCVRAM_L	; ]

	ld	bc,256
.lp1:	ldi
	ldi
	ldi
	ldi
	ldi
	ldi
	ldi
	ldi
	jp	pe,.lp1

	pop	bc
	push	bc

	ld	a,c
	call	CALCVRAM_R	; ]
	ex	de,hl

	add	a,4
	call	CALCVRAM_R	; ]

	ld	bc,320-256
.lp2:	ldi
	ldi
	ldi
	ldi
	ldi
	ldi
	ldi
	ldi
	jp	pe,.lp2

	pop	bc

	inc	c
	inc	c
	djnz	.lp3

	ld	a,$e2		; rbg}bv[h
	out	($c8),a

	ret

;
; ʃNA
;
CLSSCR:
	push	af
	push	bc
	push	hl

	xor	a
	ld	(CURX),a

	ld	a,(MINY)
	ld	(CURY),a

	ld	b,a

	add	a,a		; x2
	add	a,a		; x4
	add	a,a		; x8
	ld	c,a		; NAJns

	ld	a,(MAXY)
	inc	a
	sub	b
	add	a,a		; x2
	add	a,a		; x4
	add	a,a		; x8
	ld	b,a		; NAs

	call	CLSLINE

	pop	hl
	pop	bc
	pop	af
	ret

;
; Ns
; CFYW
; BFs
;
CLSLINE:
	ld	a,$ea		; ڃANZX[h
	out	($c8),a

	srl	b

.lp3:
	ld	a,c
	call	CALCVRAM_L
	inc	h
	ld	(.vl+1),hl

	call	CALCVRAM_R
	ld	de,$0040
	add	hl,de
	ld	(.vr+1),hl

	push	bc
	ld	hl,$8888

	di
	ld	(.sppt+1),sp

	ld	b,16
.vl:	ld	sp,$0000
.lp1:
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	djnz	.lp1

	ld	b,4
.vr:	ld	sp,$0000
.lp2:
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	push	hl
	djnz	.lp2

.sppt:	ld	sp,$0000
	ei

	pop	bc

	inc	c
	inc	c
	djnz	.lp3

	ld	a,$e2		; rbg}bv[h
	out	($c8),a

	ret

;
; VRAMAhXZoij
; AFYW
; RETURN
; HLFVRAMAhX
;
CALCVRAM_L:
	push	af

	srl	a
	add	a,$1a
	ld	h,a
	ld	l,$00

	pop	af
	ret

;
; VRAMAhXZoiEj
; AFYW
; RETURN
; HLFVRAMAhX
;
CALCVRAM_R:
	push	af

	ld	h,a

	and	$0c			; Y3,2
	add	a,a
	add	a,a
	add	a,a
	add	a,a			; Y3,2 => b7,6
	ld	l,a

	ld	a,h
	and	$f0			; Y7-4
	rrca
	rrca
	rrca				; Y7-4 => b12-9
	bit	1,h
	jr	z,.nob82
	inc	a			; Y1 => b8
.nob82:
	ld	h,a

	pop	af
	ret

;
; P\Tu
; AFLN^ԍ
;
PNTCHRSUB:
	push	hl
	push	de
	push	bc
	push	af

	ld	l,a
	ld	h,0
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,hl		; x8
	ld	de,$8800	; LN^f[^i[擪AhX
	add	hl,de
	ex	de,hl

	ld	a,(CURY)
	add	a,a		; x2
	add	a,a		; x4
	add	a,a		; x8
	ld	c,a		; YW

	ld	a,(CURX)
	ld	l,a
	ld	h,0
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,hl		; x8
	ld	(.xx+1),hl	; XW

	ld	b,8

.lp1:
	push	bc
	ld	a,c
	out	($ce),a

	ld	bc,(F_COL)

.xx:	ld	hl,$0000	; XW

	ld	a,(de)

	rlca
	ld	(hl),c		; F
	jr	c,.n1
	ld	(hl),b		; wiF
.n1:	inc	l

	rlca
	ld	(hl),c		; F
	jr	c,.n2
	ld	(hl),b		; wiF
.n2:	inc	l

	rlca
	ld	(hl),c		; F
	jr	c,.n3
	ld	(hl),b		; wiF
.n3:	inc	l

	rlca
	ld	(hl),c		; F
	jr	c,.n4
	ld	(hl),b		; wiF
.n4:	inc	l

	rlca
	ld	(hl),c		; F
	jr	c,.n5
	ld	(hl),b		; wiF
.n5:	inc	l

	rlca
	ld	(hl),c		; F
	jr	c,.n6
	ld	(hl),b		; wiF
.n6:	inc	l

	rlca
	ld	(hl),c		; F
	jr	c,.n7
	ld	(hl),b		; wiF
.n7:	inc	l

	rlca
	ld	(hl),c		; F
	jr	c,.n8
	ld	(hl),b		; wiF
.n8:
	inc	de

	pop	bc
	inc	c
	djnz	.lp1

	pop	af
	pop	bc
	pop	de
	pop	hl

	ret

;
; J[\`
; AFF
;
CURDRAW:
	push	hl
	push	bc

	ld	c,a

	ld	a,(CURX)
	ld	l,a
	ld	h,0
	add	hl,hl		; x2
	add	hl,hl		; x4
	add	hl,hl		; x8
	ld	(.xx+1),hl	; XW

	ld	a,(CURY)
	add	a,a		; x2
	add	a,a		; x4
	add	a,a		; x8 YW

	ld	b,8

.lp1:
	out	($ce),a

.xx:	ld	hl,$0000	; XW

	ld	(hl),c
	inc	l
	ld	(hl),c
	inc	l
	ld	(hl),c
	inc	l
	ld	(hl),c
	inc	l
	ld	(hl),c
	inc	l
	ld	(hl),c
	inc	l
	ld	(hl),c
	inc	l
	ld	(hl),c

	inc	a
	djnz	.lp1

	pop	bc
	pop	hl
	ret

;
; vOI
;
	org	$83ff
	db	$ff



end
