/****************************/
/* convert message          */
/*                          */
/* ͂Ђ炪Ȃɕϊ */
/****************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAXWORD		255
#define	MAXWORDLEN	16

void hiraconv(unsigned char word[MAXWORD],unsigned char newword[MAXWORD]);

int main(int argc, char **argv)
{
	FILE	*infp, *outfp;

	int		c;
	int		i;
	int		stflag,stflagold;
	unsigned char	word[MAXWORD];
	unsigned char	newword[MAXWORD];
	int		wcnt;

	if (argc != 3) {
		fprintf(stderr, "Usage: convmsg inputfile outputfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	stflag = 0;
	stflagold = 0;
	wcnt = 0;
	for (i = 0;;i ++) {
		c = fgetc(infp);
		if (c == EOF) {
			break;
		}

		if (stflag == 0) {
			if (c == 'P') {
				stflag = 1;
			}
		} else if (stflag == 1) {
			if (c == '"') {
				stflag = 2;
			} else {
				fprintf(stderr, "Message data illigal %04x\n",i);
				exit(1);
			}
		} else {
			if (c == '"') {
//				fputc('\n',outfp);
				stflag = 0;
			} else {
				if        (c == '/') {
					stflag = 2;
				} else if (c == 0xe9) {
					c = 0x81;			// n[g
					stflag = 2;
				} else if (c == 0xec) {
					c = 0x85;			// 
					stflag = 2;
				} else if (0xa1 <= c && c <= 0xa5) {
					stflag = 2;
				} else if (0xa6 <= c && c <= 0xdf) {
					if (stflag == 2) {
						wcnt = 0;
					}
					stflag = 3;
					word[wcnt] = c;
					wcnt ++;
					word[wcnt] = 0;

				} else if (0x20 <= c && c <= 0x7e) {
					stflag = 2;
				} else {
					stflag = 2;
					fprintf(stderr,"Illiga character %04x:%02x\n",i,c);
				}

			}
		}

		if (stflag != 3 && stflagold == 3) {
			hiraconv(word,newword);
			fputs(newword,outfp);
		}
		if (stflag != 3) {
			fputc(c,outfp);
		}

		stflagold = stflag;
	}



	fclose(infp);
	fclose(outfp);

	return(0);

}

void hiraconv(unsigned char word[MAXWORD],unsigned char newword[MAXWORD])
{
	int		i,j;
	int		equflag;

	unsigned char kataword[][MAXWORDLEN] = {
		"ر",
		"",
		"",
		"۰",
		"Ų",
		"׽ļ",
		"׽",
		"Ÿ",
		"ô",
		"ݷ׶Ѷ",
		"ݹɵ",
		"",
		"ƭ",
		"Ӱ",
		"",
		"",
		"ү",
		"й",
		"й",
		"",
		"ò",
		"ݹ",
		"ް",
		"ϼ",
		"İذ",
		"÷",
		"޻޲Ű",
		"ݸ",
		"",
		"",
		"",
		"",
		"",
		"ް",
		"̧ް",
		"",
		"",
		"޺",
		"Ѽ",
		"è",
		""
	};

	unsigned char kataword2[][2][MAXWORDLEN] = {
		{"Ҷ",{0x00,0x00}},
		{"Ҷ",{0x00,0x00,0x20}},
		{"Ѽ",{0x00,0x00,0x00,0xe0,0x20}},
		{"ަ",{0xe0,0xe0,0xe0,0x00,0x00,0x00,0x00,0x00,0xe0}},
		{"ĳ׽",{0x20,0x20,0x20,0xe0,0x20,0x00,0x00,0x00}},
		{"ò",{0x20,0xe0,0xe0,0xe0,0x00,0x00,0x00}},
		{"Яòɶ",{0xe0,0x23,0xe0,0x20,0xe0,0x20,0x20,0xe0}},
		{"޶",{0xe0,0x25,0x00,0xe0,0xe0,0x00}},
		{"",""}
	};


	strcpy(newword,word);


	for (i = 0;;i ++) {
		if (kataword2[i][0][0] == 0) {
			break;
		}
		if ( strcmp(kataword2[i][0],newword) == 0) {
			for (j = 0;newword[j] != 0;j ++) {
				newword[j] += kataword2[i][1][j];
			}
			return;
		}
	}


// J^JiЂ炪
	for (i = 0;newword[i] != 0;i ++) {
		if        (0xa6 <= newword[i] && newword[i] <= 0xaf) {
			newword[i] -= 0x20;
		} else if (0xb0 <= newword[i] && newword[i] <= 0xb0) {
			;
		} else if (0xb1 <= newword[i] && newword[i] <= 0xbf) {
			newword[i] -= 0x20;
		} else if (0xc0 <= newword[i] && newword[i] <= 0xdd) {
			newword[i] += 0x20;
		} else if (0xde <= newword[i] && newword[i] <= 0xdf) {
			;
		} else {
			fprintf(stderr, "Convert Error %s\n",word);
			exit(1);
		}
	}


	for (i = 0;;i ++) {

		if (kataword[i][0] == 0) {
			return;
		}

		equflag = 1;
		for (j = 0;kataword[i][j] != 0;j ++) {
			if (word[j] != kataword[i][j]) {
				equflag = 0;
				break;
			}
		}

		if (equflag != 0) {
			break;
		}

	}

// Ђ炪ȁJ^Ji
	for (i = 0;i < j;i ++) {
		newword[i] = word[i];
	}

	return;

}
