/****************************************************/
/* make filelist                                    */
/*                                                  */
/* t@CZN^PʂŊi[邽߂̃Xg */
/****************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAXFILE		63
#define	MAXNAME		16


int main(int argc, char **argv)
{
	FILE	*infp, *outbinfp, *outtxtfp, *flistfp;

	int		i,j;
	char	fname[MAXNAME];
	int		dmyst;
	int		filelen;
	int		readflag;

	int		trackno, secno;

	if (argc != 6) {
		fprintf(stderr, "Usage: mkflist starttrack startsector inputlist outbinlist outtxtlist\n");
		exit(1);
	}

	trackno = atoi(argv[1]);
	secno   = atoi(argv[2]);

/* open files */

	if ((infp = fopen(argv[3], "r")) == NULL) {
		perror(argv[3]);
		exit(1);
	}

	if ((outbinfp = fopen(argv[4], "wb")) == NULL) {
		perror(argv[4]);
		exit(1);
	}

	if ((outtxtfp = fopen(argv[5], "w")) == NULL) {
		perror(argv[5]);
		exit(1);
	}

	for (i = 0;i < MAXFILE;i ++) {
		if (fscanf(infp,"%s",fname) == EOF) {
			break;
		}
		fscanf(infp,"%d",dmyst);
		fscanf(infp,"%d",dmyst);
		fscanf(infp,"%d",dmyst);
		fscanf(infp,"%d",dmyst);

		if ((flistfp = fopen(fname, "rb")) == NULL) {
			perror(fname);
			exit(1);
		}

		fseek(flistfp, 0, SEEK_END);
		filelen = ftell(flistfp);
		filelen = ( (filelen+0x00ff) & 0xff00);
		fclose(flistfp);

		fputc(trackno, outbinfp);
		fputc(secno+1, outbinfp);
		fputc( (filelen >> 8), outbinfp);

		fprintf(outtxtfp,"%s 0 %d %d\n", fname, trackno, secno+1);


		secno   = secno + (filelen >> 8);
		trackno = trackno + ( (secno & 0xfff0) >> 4);
		secno   = (secno & 0x000f);
	}

	for (i = ftell(outbinfp);i < 0x0100;i ++) {
		fputc(0xff,outbinfp);
	}

	fclose(infp);
	fclose(outbinfp);
	fclose(outtxtfp);

	return(0);

}

